/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.google.appengine.api.datastore.Query;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.dto.CmAuthorityDto;

/**
 * CM_AUTHORITY(権限マスタ)のDAOクラス 。
 */
public class CmAuthorityDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * CM_AUTHORITY(権限マスタ)。
	 */
	public static final String	TABLE			= "CM_AUTHORITY";
	
	/**
	 * KEY_1 = AUTHCODE(権限コード)。
	 */
	public static final String	KEY_1			= "AUTHCODE";
	
	// 列名
	/**
	 * AUTHCODE(権限コード)。
	 */
	public static final String	COL_AUTHCODE	= "AUTHCODE";
	/**
	 * AUTHNAME(権限ネーム)。
	 */
	public static final String	COL_AUTHNAME	= "AUTHNAME";
	/**
	 * EMPLOYEE(従業員メニュー)。
	 */
	public static final String	COL_EMPLOYEE	= "EMPLOYEE";
	/**
	 * MANAGER(マネージャーメニュー)。
	 */
	public static final String	COL_MANAGER		= "MANAGER";
	/**
	 * PAYROLL(給与メニュー)。
	 */
	public static final String	COL_PAYROLL		= "PAYROLL";
	/**
	 * HUMAN(人事メニュー)。
	 */
	public static final String	COL_HUMAN		= "HUMAN";
	/**
	 * INSURANCE(社会保険メニュー)。
	 */
	public static final String	COL_INSURANCE	= "INSURANCE";
	/**
	 * BONUS(賞与メニュー)。
	 */
	public static final String	COL_BONUS		= "BONUS";
	/**
	 * ADJUSTMENT(年末調整メニュー)。
	 */
	public static final String	COL_ADJUSTMENT	= "ADJUSTMENT";
	/**
	 * EXPENSE(経費メニュー)。
	 */
	public static final String	COL_EXPENSE		= "EXPENSE";
	/**
	 * SERVICE1(サービス１メニュー)。
	 */
	public static final String	COL_SERVICE1	= "SERVICE1";
	/**
	 * SERVICE2(サービス２メニュー)。
	 */
	public static final String	COL_SERVICE2	= "SERVICE2";
	/**
	 * SERVICE3(サービス３メニュー)。
	 */
	public static final String	COL_SERVICE3	= "SERVICE3";
	/**
	 * SERVICE4(サービス４メニュー)。
	 */
	public static final String	COL_SERVICE4	= "SERVICE4";
	/**
	 * SERVICE5(サービス５メニュー)。
	 */
	public static final String	COL_SERVICE5	= "SERVICE5";
	/**
	 * DELETEFLAG(削除フラグ)。
	 */
	public static final String	COL_DELETEFLAG	= "DELETEFLAG";
	

	/**
	 * コンストラクタ
	 */
	public CmAuthorityDao() {
		super();
	}
	
	/**
	 * 検索結果取得(DTOのList)
	 * @return List 検索リスト
	 * @throws SQLException SQL例外が発生した場合
	 */
	private List<CmAuthorityDto> mappingAll() throws SQLException {
		List<CmAuthorityDto> all = new ArrayList<CmAuthorityDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)
	 * @return cm_serviceDto cm_serviceレコード
	 * @throws SQLException SQL例外が発生した場合
	 */
	private CmAuthorityDto mapping() throws SQLException {
		CmAuthorityDto dto = new CmAuthorityDto();
		dto.setAuthCode(rs.getString(COL_AUTHCODE)); //権限コード
		dto.setAuthName(rs.getString(COL_AUTHNAME)); //権限ネーム
		dto.setEmployee(rs.getString(COL_EMPLOYEE)); //従業員メニュー
		dto.setManager(rs.getString(COL_MANAGER)); //マネージャーメニュー
		dto.setPayroll(rs.getString(COL_PAYROLL)); //給与メニュー
		dto.setHuman(rs.getString(COL_HUMAN)); //人事メニュー
		dto.setInsurance(rs.getString(COL_INSURANCE)); //社会保険メニュー
		dto.setBonus(rs.getString(COL_BONUS)); //賞与メニュー
		dto.setAdjustment(rs.getString(COL_ADJUSTMENT)); //年末調整メニュー
		dto.setExpense(rs.getString(COL_EXPENSE)); //経費メニュー
		dto.setService1(rs.getString(COL_SERVICE1));
		dto.setService2(rs.getString(COL_SERVICE2));
		dto.setService3(rs.getString(COL_SERVICE3));
		dto.setService4(rs.getString(COL_SERVICE4));
		dto.setService5(rs.getString(COL_SERVICE5));
		dto.setDeleteFlag(rs.getInt(COL_DELETEFLAG)); //削除フラグ
		return dto;
	}
	
	/**
	 * 全データ取得
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<CmAuthorityDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			List<CmAuthorityDto> all = mappingAll();
			return all;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得
	 * @param authcode 権限コード(検索キー)
	 * @return CmAuthorityDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmAuthorityDto findForKey(String authcode) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, authcode);
			executeQuery();
			CmAuthorityDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param authcode 権限コード(検索キー)
	 * @return CmAuthorityDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmAuthorityDto findForUpdate(String authcode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, authcode);
			executeQuery();
			CmAuthorityDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param authcode 権限コード
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForCondition(String authcode) throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
//		sb.append(MosPDao.like(COL_AUTHCODE));
		this.pob.appendLike(COL_AUTHCODE);
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, authcode);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * @return	検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<CmAuthorityDto> findForAvailable() throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
//		sb.append(MosPDao.deleteFlagOff(COL_DELETEFLAG));
		this.pob.appendWhere(COL_DELETEFLAG, Query.FilterOperator.EQUAL, MospConst.DELETE_FLAG_OFF);
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文による検索データ取得
	 * @param authcode 権限コード
	 * @param authname 	検索名称
	 * @param employee 	従業員メニュー
	 * @param manager 	マネージャーメニュー
	 * @param payroll 	給与メニュー
	 * @param human 	人事メニュー
	 * @param deleteflag 検索削除フラグ
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForFunctionCondition(String authcode, String authname, String employee, String manager,
			String payroll, String human, String deleteflag) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
/*		sb.append("WHERE ");
		sb.append(MosPDao.like(COL_AUTHCODE));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_AUTHNAME));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_EMPLOYEE));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_MANAGER));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_PAYROLL));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_HUMAN));*/
		this.pob.appendLike(COL_AUTHCODE);
		this.pob.appendLike(COL_AUTHNAME);
		this.pob.appendLike(COL_EMPLOYEE);
		this.pob.appendLike(COL_MANAGER);
		this.pob.appendLike(COL_PAYROLL);
		this.pob.appendLike(COL_HUMAN);
		
		if (MosPDao.isNotNull(deleteflag)) {
			sb.append("AND ");
//			sb.append(MosPDao.equal(COL_DELETEFLAG));
			this.pob.appendWhere(COL_DELETEFLAG, Query.FilterOperator.EQUAL);
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, MosPDao.startWithParam(authcode));
			setParam(index++, MosPDao.containsParam(authname));
			setParam(index++, MosPDao.containsParam(employee));
			setParam(index++, MosPDao.containsParam(manager));
			setParam(index++, MosPDao.containsParam(payroll));
			setParam(index++, MosPDao.containsParam(human));
			if (MosPDao.isNotNull(deleteflag)) {
				setParam(index++, Integer.parseInt(deleteflag));
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文による検索データ取得
	 * @param authcode 権限コード
	 * @param authname 	検索名称
	 * @param employee 	従業員メニュー
	 * @param manager 	マネージャーメニュー
	 * @param payroll 	給与メニュー
	 * @param human 	人事メニュー
	 * @param service1 	その他１メニュー
	 * @param service2 	その他２メニュー
	 * @param deleteflag 検索削除フラグ
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForFunctionCondition(String authcode, String authname, String employee, String manager,
			String payroll, String human, String service1, String service2, String deleteflag) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
/*		sb.append("WHERE ");
		sb.append(MosPDao.like(COL_AUTHCODE));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_AUTHNAME));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_EMPLOYEE));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_MANAGER));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_PAYROLL));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_HUMAN));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_SERVICE1));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_SERVICE2));*/
		this.pob.appendLike(COL_AUTHCODE);
		this.pob.appendLike(COL_AUTHNAME);
		this.pob.appendLike(COL_EMPLOYEE);
		this.pob.appendLike(COL_MANAGER);
		this.pob.appendLike(COL_PAYROLL);
		this.pob.appendLike(COL_HUMAN);
		this.pob.appendLike(COL_SERVICE1);
		this.pob.appendLike(COL_SERVICE2);
		if (MosPDao.isNotNull(deleteflag)) {
			sb.append("AND ");
//			sb.append(MosPDao.equal(COL_DELETEFLAG));
			this.pob.appendWhere(COL_DELETEFLAG, Query.FilterOperator.EQUAL);
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, MosPDao.startWithParam(authcode));
			setParam(index++, MosPDao.containsParam(authname));
			setParam(index++, MosPDao.containsParam(employee));
			setParam(index++, MosPDao.containsParam(manager));
			setParam(index++, MosPDao.containsParam(payroll));
			setParam(index++, MosPDao.containsParam(human));
			setParam(index++, MosPDao.containsParam(service1));
			setParam(index++, MosPDao.containsParam(service2));
			if (MosPDao.isNotNull(deleteflag)) {
				setParam(index++, deleteflag);
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得（有効のみ）
	 * @param authcode 権限コード(検索キー)
	 * @return CmAuthorityDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmAuthorityDto findForAuth(String authcode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
/*			sb.append("WHERE ");
			sb.append(MosPDao.deleteFlagOff(COL_DELETEFLAG));
			sb.append("AND ");
			sb.append(MosPDao.equal(COL_AUTHCODE));*/
			this.pob.appendWhere(COL_DELETEFLAG, Query.FilterOperator.EQUAL, MospConst.DELETE_FLAG_OFF);
			this.pob.appendWhere(COL_AUTHCODE, Query.FilterOperator.EQUAL);
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, authcode);
			executeQuery();
			CmAuthorityDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException	MosP例外処理が発生した場合
	 */
	public int insert(CmAuthorityDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException	MosP例外処理が発生した場合
	 */
	public int update(CmAuthorityDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getAuthCode());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定
	 * @param dto 更新対象DTO
	 * @param isInsert  挿入文フラグ(true：挿入文、false：更新文)
	 * @throws SQLException SQL例外が発生した場合
	 */
	private void setParams(CmAuthorityDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getAuthCode()); //サービスコード
		setParam(index++, dto.getAuthName()); //サービスネーム
		setParam(index++, dto.getEmployee()); //従業員メニュー
		setParam(index++, dto.getManager()); //マネージャーメニュー
		setParam(index++, dto.getPayroll()); //給与メニュー
		setParam(index++, dto.getHuman()); //人事メニュー
		setParam(index++, dto.getInsurance()); //社会保険メニュー
		setParam(index++, dto.getBonus()); //賞与メニュー
		setParam(index++, dto.getAdjustment()); //年末調整メニュー
		setParam(index++, dto.getExpense()); //経費メニュー
		setParam(index++, dto.getService1());
		setParam(index++, dto.getService2());
		setParam(index++, dto.getService3());
		setParam(index++, dto.getService4());
		setParam(index++, dto.getService5());
		setParam(index++, dto.getDeleteFlag()); //削除フラグ
		setCommonParams(isInsert);
	}
	
}
